--***Air-to-Air BVR Duel Version 4.30
--********* DATA ENTRY SECTION *********--

--DateFormat = "PRO" --"CMO"

if DebugModeOPFOR == 1 then --play as OPFOR for debugging
	ScenEdit_AddSide({Name="OPFOR"})
	ScenEdit_AddSide({Name="Player"})
else	--normal play
	ScenEdit_AddSide({Name="Player"})
	ScenEdit_AddSide({Name="OPFOR"})
end

ScenEdit_SetSidePosture("Player", "OPFOR", "H")
ScenEdit_SetSidePosture("OPFOR", "Player", "H")

playerCallsign = {} 
playerCallsign[1] = 'Cowboy'
playerCallsign[2] = 'Gunslinger'
playerCallsign[3] = 'Sheriff'
playerCallsign[4] = 'Outlaw'

enemyCallsign = 'Red'

EnemyEMCON = string.gsub(EnemyEMCON,"_","=")
EnemyEMCON = string.gsub(EnemyEMCON,"|",";")

PlayerEMCON = string.gsub(PlayerEMCON,"_","=")
PlayerEMCON = string.gsub(PlayerEMCON,"|",";")

--***Define Airfields
PlayerAirfield1= {name="RAF Lakenheath",  latitude='N 52.24.35' , longitude='E 0.33.41',  heading= 236.0}
PlayerAirfield2= {name="King Faisal AB",  latitude='N 28.22.32' , longitude='E 36.38.12',  heading= 245.0}
PlayerAirfield3= {name="Nellis AFB",  latitude='N 36.14.11' , longitude='W 115.01.54',  heading= 220.0}
PlayerAirfield4= {name="Ramstein AB",  latitude='N 49.26.12',   longitude='E 7.35.45',  heading= 86.0 }
PlayerAirfield5= {name="Da Nang AB",  latitude='N 16.02.38' , longitude='E 108.11.58',  heading= 350.0}
PlayerAirfield6= {name="Aviano AB",  latitude='N 46.01.52' , longitude='E 12.35.48',  heading= 48.0}  
PlayerAirfield7= {name="Kunsan AB",  latitude='N 35.54.13' , longitude='E 126.36.58',  heading= 349.0}  
PlayerAirfield8= {name="Ramat David AB",  latitude='N 32.39.34' , longitude='E 35.10.29',  heading= 108.0}  
PlayerAirfield9= {name="Chitose AB",  latitude='N 42.47.25' , longitude='E 141.40.09',  heading= 353.0} 
PlayerAirfield10= {name="RAF Mount Pleasant",  latitude='S 51.49.16' , longitude='W 58.27.14',  heading= 285.0} 
PlayerAirfield11= {name="Ärna AB",  latitude='N 59.53.50' , longitude='E 17.35.19',  heading= 33.0} 
PlayerAirfield12= {name="Halwara AFS",  latitude='N 30.44.54' , longitude='E 75.37.49',  heading= 311.0} 
PlayerAirfield13= {name="Kadena AB",  latitude='N 26.21.22' , longitude='E 127.45.54',  heading= 51.0} 
PlayerAirfield14= {name="Tallil AB (Ali AB)",  latitude='N 30.56.01' , longitude='E 46.05.19',  heading= 299.0} 
PlayerAirfield15= {name="Tyndall AFB",  latitude='N 30.04.17' , longitude='W 85.34.26',  heading= 135.0} 
PlayerAirfield16= {name="Menongue AP",  latitude='S 14.39.24' , longitude='E 17.43.12',  heading= 298.0}  
PlayerAirfield17= {name="Incirlik AB",  latitude='N 37.00.08' , longitude='E 35.25.34',  heading= 53.0} 
PlayerAirfield18= {name="Captain German Olano Moreno AB",  latitude='N 5.29.03' , longitude='W 74.39.26',  heading= 182.0}  
PlayerAirfield19= {name="Vasylkiv AB",  latitude='N 50.14.04' , longitude='E 30.18.04',  heading= 313.0}   --Need to check
PlayerAirfield20= {name="Da Nang AB",  latitude='N 16.02.38' , longitude='E 108.11.58',  heading= 350.0} 
PlayerAirfield21= {name="Sigonella AB",  latitude='N 37.24.06' , longitude='E 14.55.22',  heading= 280.0}

OPFORAirfield1= {name="Soesterberg AB",  latitude='N 52.07.38',   longitude='E 5.16.31',  heading= 90.0 }
OPFORAirfield2= {name="H3",  latitude='N 32.55.20' , longitude='E 39.44.47',  heading= 65.0}
OPFORAirfield3= {name="NAS Fallon",  latitude='N 39.25.10',   longitude='W 118.41.57',  heading= 145.0 }
OPFORAirfield4= {name="Preschen AF",  latitude='N 51.39.50',   longitude='E 14.38.05',  heading= 66.0 }
OPFORAirfield5= {name="Phuc Yen AB",  latitude='N 21.13.16',  longitude='E 105.48.26',  heading= 290.0}
OPFORAirfield6= {name="Batajnica AB",  latitude='N 44.55.51',  longitude='E 20.15.44',  heading= 305.0}
OPFORAirfield7= {name="Sunchon AB",  latitude='N 39.24.45',  longitude='E 125.53.25',  heading= 325.0} 
OPFORAirfield8= {name="Shayrat AB",  latitude='N 34.29.24',  longitude='E 36.54.32',  heading= 111.0} 
OPFORAirfield9= {name="Yelizovo AB",  latitude='N 53.10.09',  longitude='E 158.27.02',  heading= 337.0} 
OPFORAirfield10= {name="San Julián AF",  latitude='S 49.18.24',  longitude='W 67.48.07',  heading= 79.0} 
OPFORAirfield11= {name="Chernyakhovsk AB",  latitude='N 54.36.07',  longitude='E 21.47.00',  heading= 59.0}
OPFORAirfield12= {name="PAF Minhas",  latitude='N 33.52.08',  longitude='E 72.24.06',  heading= 302.0} 
OPFORAirfield13= {name="Wuyishan AB",  latitude='N 27.42.06',  longitude='E 118.00.01',  heading= 204.0}
OPFORAirfield14= {name="Shiraz AB",  latitude='N 29.32.12',  longitude='E 52.35.25',  heading= 294.0}
OPFORAirfield15= {name="San Antonio de los Banos AB",  latitude='N 22.51.46',  longitude='W 82.31.22',  heading= 54.0} 
--OPFORAirfield16= {name="AFB Waterkloof",  latitude='S 25.49.48',  longitude='E 28.13.21',  heading= 60.0}  --Too far away
OPFORAirfield16= {name="Ondangwa AP",  latitude='S 17.52.41',  longitude='E 15.57.09',  heading= 65.0}  
OPFORAirfield17= {name="Krymsk AB",  latitude='N 44.57.46',  longitude='E 37.59.56',  heading= 47.0}  
OPFORAirfield18= {name="Captain Manuel Rios AB",  latitude='N 9.22.19',  longitude='W 66.55.26',  heading= 79.0}
OPFORAirfield19= {name="Kursk/Vostochnyy AB",  latitude='N 51.45.01',  longitude='E 36.17.46',  heading= 304.0}         
OPFORAirfield20= {name="Woody Island AS",  latitude='N 16.49.58',  longitude='E 112.20.38',  heading= 45.0}  
OPFORAirfield21= {name="Misratah AB",  latitude='N 32.19.32',  longitude='E 15.03.39',  heading= 324.0} 

--For switching airfields
playerAirfieldSide = "Player"
OPFORAirfieldSide = "OPFOR"

--Database ID numbers of the single unit airfields 
SingleUnitAirfieldDB3000 = 1877  --DBID of single unit airfierld in DB3000 as of v492 
SingleUnitAirfieldCWDB = 1568  --DBID of single unit airfierld in CWDB as of v492 

ROETable={
	{description='WEAPONS_FREE', value=0},
	{description='WEAPONS_TIGHT', value=1},
	{description='WEAPONS_HOLD', value=2},
}

for k,v in ipairs (ROETable) do
	--if v.description == EnemyROE then ROEValue = v.value end
	if v.value == EnemyROE then ROEValue = v.value end
end

function ReturnClassAndLoadout(targetString,delimiter)
	local delimiter = string.find(targetString,delimiter)
	local extractedClass = string.sub(targetString,1,delimiter-1)
	local extractedLoadout = string.sub(targetString,delimiter+1,string.len(targetString))
	return {dbid = extractedClass,loadout = extractedLoadout}
end

function ReturnLatAndLon(targetString,delimiter)
	local delimiter = string.find(targetString,delimiter)
	local extractedLat = string.sub(targetString,1,delimiter-1)
	local extractedLon = string.sub(targetString,delimiter+1,string.len(targetString))
	return {lat = extractedLat,lon = extractedLon}
end

function AddFingerFour(callsign,side,dbid,loadout,latitudeIn,longitudeIn,heading,altitude,proficiency,groupName, spacingMultiplier, formationIn) --Now sets the formation, but obsolete
	--local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	local position
	local bearingInFormation, distanceInFormation
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	--if quantity < 1 then quantity = 0 end
		for i = 1, 4 do
			if i == 1 then
				position = {latitude=latitudeIn, longitude=longitudeIn}
			elseif i == 2 then 
				position = {latitude=latitudeIn-(0.002*spacingMultiplier), longitude=longitudeIn-(0.002*spacingMultiplier)}
			elseif i == 3 then
				position = {latitude=latitudeIn-(0.002*spacingMultiplier), longitude=longitudeIn+(0.002*spacingMultiplier)}
			elseif i == 4 then	
				position = {latitude=latitudeIn-(0.004*spacingMultiplier), longitude=longitudeIn+(0.004*spacingMultiplier)}
			else
				position = {latitude=latitudeIn,longitude=longitudeIn}
			end
			
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			bearingInFormation, distanceInFormation=GetPlaceInFormation(i, spacingMultiplier, formationIn, heading)
			unit.formation = {type='rotating', bearing=bearingInFormation, distance=distanceInFormation, sprint='false'}
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddFormationX(numberIn, callsign,side,dbid,loadout,latitudeIn,longitudeIn,heading,altitude,proficiency,groupName, spacingMultiplier, formationIn)
	--local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	local position
	local bearingInFormation, distanceInFormation
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	--if quantity < 1 then quantity = 0 end
		for i = 1, numberIn do
			if i == 1 then  --Group Lead
				position = {latitude=latitudeIn, longitude=longitudeIn}
				bearingInFormation = 0
				distanceInFormation = 0
			else
				bearingInFormation, distanceInFormation=GetPlaceInFormation(i, spacingMultiplier, formationIn, heading)
				position = World_GetPointFromBearing({latitude = latitudeIn, longitude = longitudeIn, distance = distanceInFormation, bearing = bearingInFormation})
			end
			
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			unit.formation = {type='rotating', bearing=bearingInFormation, distance=distanceInFormation, sprint='false'}
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddMultipleAircraft(quantity,callsign,side,dbid,loadout,latitude,longitude,heading,altitude)
	local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local position
	local addedAircraftTable = {}
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	if quantity < 1 then quantity = 1 end
		for i = 1, quantity do
			if i > 1 then
				position = circle[i-1]
			else
				position = {latitude=latitude,longitude=longitude}
			end
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude}) --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function GetPlaceInFormation(j, spacingMultiplierIn, formationIn, headingIn)
	local bearingOut, distanceOut 
	
	if j == 2 then 
	
		if formationIn == "FingerFour" then 
			bearingOut = (225+headingIn)%360
		elseif formationIn == "LineAbreast" then  
			bearingOut = (270+headingIn)%360
		elseif formationIn == "EchelonRight" then  
			bearingOut = (315+headingIn)%360
		elseif formationIn == "EchelonLeft" then  
			bearingOut = (45+headingIn)%360
		elseif formationIn == "LineAstern" then  
			bearingOut = (0+headingIn)%360
		else 
			bearingOut = 270+headingIn%360  --LineAbreast default in case formationIn is not recognized
		end
	
	elseif j == 3 or j == 4 then
	
		if formationIn == "FingerFour" then 
			bearingOut = (135+headingIn)%360
		elseif formationIn == "LineAbreast" then  
			bearingOut = (90+headingIn)%360
		elseif formationIn == "EchelonRight" then  
			bearingOut = (135+headingIn)%360
		elseif formationIn == "EchelonLeft" then  
			bearingOut = (225+headingIn)%360
		elseif formationIn == "LineAstern" then  
			bearingOut = (180+headingIn)%360
		else 
			bearingOut = (90+headingIn)%360  --LineAbreast default in case formationIn is not recognized
		end
		
	else
		bearingOut = (90+headingIn)%360
	end
	
	
	distanceOut = (250.0/1852.0)*spacingMultiplierIn 
	
	if j == 4 then 
		distanceOut = 2 * distanceOut 
	end 
	
	return bearingOut, distanceOut 
end 

--New function to set A2A WRA Max Range. Especially important in the new missile model introduced in the beta. The WRA is set at the SIDE level
function SetA2A_WRA_MaxRange(side)
	
	local loadout
	local WRArangeFactor
	local modInt
	local weapObj
	local weapObjMaxRange
	local WRArangeRaw
	local WRArangeModulo
	local WRArange
	local wra
	local unitDummy
	local string1, string2, string3, string4, string5, string6, string7

	string7 = ""
	--Need to input a unit and not a loadout string to access the loadout object
	if side == "Player" then
		unitDummy = playerCallsign[1].." #1"
	else
		unitDummy = enemyCallsign.."1 #1"
	end
	
	loadout = ScenEdit_GetLoadout ({UnitName = unitDummy, LoadoutID = 0})
	if loadout == nil then
		loadout = ScenEdit_GetLoadout({UnitName = playerCallsign[1].." #1", LoadoutID = enemyAircraft.loadout})  --for when enemy has 0 units, to avoid an error
	end 
	
	for k,v in ipairs (loadout.weapons) do

		if loadout.weapons[k].wpn_type == 2001 then --Only applies to guided missiles
			string1 = loadout.weapons[k].wpn_dbid..'->'..loadout.weapons[k].wpn_name
		
			weapObj = ScenEdit_QueryDB ('weapon', loadout.weapons[k].wpn_dbid)
			weapObjMaxRange = weapObj.ranges.air.max
			string2 = 'Missile Max Range = '..weapObjMaxRange.." nm"
		
			modInt = 5  --Most A2A missiles have a WRA range resolution of 5nm -> Modulo 5
			nezString = "n"  --String that user can input for No Escape Zone    
			--Set the range factor for either player or Opfor and depending on if its for a BVR or WVR missile
			if side == "Player" and weapObjMaxRange >  BVRtoWVRcutoff then
				if PlayerWRA_BVR ~= nezString then
					WRArangeFactor =  PlayerWRA_BVR/100
				else
					WRArangeRaw = "N/A"
					WRArangeModulo = "N/A"
					WRArange = "NEZ"
					goto Post_Math	
				end	
			elseif side == "Player" and weapObjMaxRange <=  BVRtoWVRcutoff  then  -- For WVR Missiles
				if PlayerWRA_WVR ~= nezString then
					WRArangeFactor =  PlayerWRA_WVR/100
				else
					WRArangeRaw = "N/A"
					WRArangeModulo = "N/A"
					WRArange = "NEZ"
					goto Post_Math	
				end
			elseif weapObjMaxRange >  BVRtoWVRcutoff then  --Assume if it's not "Player, then it is for OpFor   
				if EnemyWRA_BVR ~= nezString then
					WRArangeFactor =  EnemyWRA_BVR/100
				else
					WRArangeRaw = "N/A"
					WRArangeModulo = "N/A"
					WRArange = "NEZ"
					goto Post_Math	
				end	
			else                                        --Default is the OpFor WVR missile 
				if EnemyWRA_WVR ~= nezString then				
					WRArangeFactor =  EnemyWRA_WVR/100
				else
					WRArangeRaw = "N/A"
					WRArangeModulo = "N/A"
					WRArange = "NEZ"
					goto Post_Math	
				end		
			end
			
			WRArangeRaw = WRArangeFactor * weapObjMaxRange 	-- This is the raw new WRA range
			
			
			if weapObjMaxRange <=  BVRtoWVRcutoff and WRArangeRaw < 5 then   --This is to cover some WVR missiles that have a lower WRA Max Range setting of 2nm below the normal 5 nm resolution 
				modInt = 2
			end
		
			WRArangeModulo = WRArangeRaw % modInt   --Need to fit the raw maximum range into the available 5nm (or 2nm) resolution. Calculate modulo to do that

			

			if WRArangeModulo < 0.5*modInt  then       --This section is to figure out rounding-up vs. rounding-down to the nearest 5nm (or 2nm) resolution block. 
				WRArange = WRArangeRaw - WRArangeModulo
			else
				WRArange = WRArangeRaw + (modInt - WRArangeModulo)
			end
        
			::Post_Math::
			string3 = "Raw WRA Range = "..WRArangeRaw.. " nm" 
			string4 = "The modulo value is: "..WRArangeModulo
			string5 = "New WRA Range Should Be = "..WRArange.." nm"

			--WRArange = WRArange.."" --Cast to string

				  ScenEdit_SetDoctrineWRA ({side = side, weapon_id = loadout.weapons[k].wpn_dbid , target_type = "1999"},{"inherit", "inherit", WRArange, "system"})  --Unknown Target
				  ScenEdit_SetDoctrineWRA ({side = side, weapon_id = loadout.weapons[k].wpn_dbid , target_type = "2000"},{"inherit", "inherit", WRArange, "system"})  --All Aircraft Targets
				  wra = ScenEdit_GetDoctrineWRA ({side = side, weapon_id = loadout.weapons[k].wpn_dbid , target_type = "2000"})  --All Aircraft Targets 
			
			string6 = "New WRA Range is Actually = "..wra.WRA.FIRING_RANGE.. " nm"
			
			string7 = string7.."<br>"..string1.."<br>"..string2.."<br>"..string3.."<br>"..string4.."<br>"..string5.."<br>"..string6.."<br><br>"
		end
	end
	
	if DebugModeWRA == "1" or DebugModeWRA == 1	 then
		ScenEdit_SpecialMessage('playerside',string7)
		--ScenEdit_MsgBox(string7, 1)
	end
	
	return wra
end

--***Convert altitudes to feet
StartAltitude = StartAltitude.." FT"
EnemyAltitude = EnemyAltitude.." FT"

location = ReturnLatAndLon(combatLatLon,'_')

--***Airfields
if switchAF == 1 then
	playerAirfieldSide = "OPFOR" 
	OPFORAirfieldSide = "Player"
	playerRadialOrientation = 0 
 else
	playerRadialOrientation = 180
end

if DB == "CWDB" then
	SingleUnitAirfield = SingleUnitAirfieldCWDB 
elseif DB == "DB3000" then 
	SingleUnitAirfield = SingleUnitAirfieldDB3000 
else
	ScenEdit_MsgBox ("Database could not be determined. Assuming DB3000.", 1)
	SingleUnitAirfield = SingleUnitAirfieldDB3000 
end


if location.lat == '56.14' then  --North Sea
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield1.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield1.latitude, longitude=PlayerAirfield1.longitude, heading=PlayerAirfield1.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield1.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield1.latitude, longitude=OPFORAirfield1.longitude, heading=OPFORAirfield1.heading})
elseif location.lat == '31.16' then --Iraq / Saudi Arabia Border 
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield2.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield2.latitude, longitude=PlayerAirfield2.longitude, heading=PlayerAirfield2.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield2.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield2.latitude, longitude=OPFORAirfield2.longitude, heading=OPFORAirfield2.heading})
elseif location.lat == '36.82' then --Nevada, U.S.
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield3.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield3.latitude, longitude=PlayerAirfield3.longitude, heading=PlayerAirfield3.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield3.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield3.latitude, longitude=OPFORAirfield3.longitude, heading=OPFORAirfield3.heading})
elseif location.lat == '51.51' then --Central Europe
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield4.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield4.latitude, longitude=PlayerAirfield4.longitude, heading=PlayerAirfield4.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield4.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield4.latitude, longitude=OPFORAirfield4.longitude, heading=OPFORAirfield4.heading})
elseif location.lat == '17.42' then --Vietnam
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield5.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield5.latitude, longitude=PlayerAirfield5.longitude, heading=PlayerAirfield5.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield5.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield5.latitude, longitude=OPFORAirfield5.longitude, heading=OPFORAirfield5.heading})
elseif location.lat == '44.79' then --Balkans
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield6.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield6.latitude, longitude=PlayerAirfield6.longitude, heading=PlayerAirfield6.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield6.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield6.latitude, longitude=OPFORAirfield6.longitude, heading=OPFORAirfield6.heading})
elseif location.lat == '38.50' then --Korea
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield7.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield7.latitude, longitude=PlayerAirfield7.longitude, heading=PlayerAirfield7.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield7.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield7.latitude, longitude=OPFORAirfield7.longitude, heading=OPFORAirfield7.heading})
elseif location.lat == '33.83' then --Lavant
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield8.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield8.latitude, longitude=PlayerAirfield8.longitude, heading=PlayerAirfield8.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield8.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield8.latitude, longitude=OPFORAirfield8.longitude, heading=OPFORAirfield8.heading})
elseif location.lat == '46.00' then --Kuril Islands
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield9.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield9.latitude, longitude=PlayerAirfield9.longitude, heading=PlayerAirfield9.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield9.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield9.latitude, longitude=OPFORAirfield9.longitude, heading=OPFORAirfield9.heading})
elseif location.lat == '-51.50' then --Falkland Islands/Malvinas 
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield10.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield10.latitude, longitude=PlayerAirfield10.longitude, heading=PlayerAirfield10.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield10.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield10.latitude, longitude=OPFORAirfield10.longitude, heading=OPFORAirfield10.heading})
elseif location.lat == '57.30' then --The Baltic
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield11.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield11.latitude, longitude=PlayerAirfield11.longitude, heading=PlayerAirfield11.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield11.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield11.latitude, longitude=OPFORAirfield11.longitude, heading=OPFORAirfield11.heading})
elseif location.lat == '33.00' then --Kashmir
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield12.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield12.latitude, longitude=PlayerAirfield12.longitude, heading=PlayerAirfield12.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield12.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield12.latitude, longitude=OPFORAirfield12.longitude, heading=OPFORAirfield12.heading})
elseif location.lat == '26.50' then --East China Sea
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield13.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield13.latitude, longitude=PlayerAirfield13.longitude, heading=PlayerAirfield13.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield13.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield13.latitude, longitude=OPFORAirfield13.longitude, heading=OPFORAirfield13.heading})
elseif location.lat == '29.50' then --Iraq / Iran
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield14.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield14.latitude, longitude=PlayerAirfield14.longitude, heading=PlayerAirfield14.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield14.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield14.latitude, longitude=OPFORAirfield14.longitude, heading=OPFORAirfield14.heading})
elseif location.lat == '27.00' then --Gulf of Mexico
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield15.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield15.latitude, longitude=PlayerAirfield15.longitude, heading=PlayerAirfield15.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield15.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield15.latitude, longitude=OPFORAirfield15.longitude, heading=OPFORAirfield15.heading})
elseif location.lat == '-15.10' then --South West Africa/Angola
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield16.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield16.latitude, longitude=PlayerAirfield16.longitude, heading=PlayerAirfield16.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield16.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield16.latitude, longitude=OPFORAirfield16.longitude, heading=OPFORAirfield16.heading})
elseif location.lat == '43.00' then --Black Sea
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield17.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield17.latitude, longitude=PlayerAirfield17.longitude, heading=PlayerAirfield17.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield17.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield17.latitude, longitude=OPFORAirfield17.longitude, heading=OPFORAirfield17.heading})
elseif location.lat == '7.50' then --South America (Colombia / Venezuela)
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield18.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield18.latitude, longitude=PlayerAirfield18.longitude, heading=PlayerAirfield18.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield18.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield18.latitude, longitude=OPFORAirfield18.longitude, heading=OPFORAirfield18.heading})
elseif location.lat == '51.00' then --Ukraine
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield19.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield19.latitude, longitude=PlayerAirfield19.longitude, heading=PlayerAirfield19.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield19.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield19.latitude, longitude=OPFORAirfield19.longitude, heading=OPFORAirfield19.heading})
elseif location.lat == '15.25' then --South China Sea
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield20.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield20.latitude, longitude=PlayerAirfield20.longitude, heading=PlayerAirfield20.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield20.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield20.latitude, longitude=OPFORAirfield20.longitude, heading=OPFORAirfield20.heading})
elseif location.lat == '34.00' then --Libya
	PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield21.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield21.latitude, longitude=PlayerAirfield21.longitude, heading=PlayerAirfield21.heading})
	OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield21.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield21.latitude, longitude=OPFORAirfield21.longitude, heading=OPFORAirfield21.heading})
--elseif location.lat == '' then --
	--PlayerAirfield=ScenEdit_AddUnit({side=playerAirfieldSide, type='Facility', name=PlayerAirfield22.name, dbid=SingleUnitAirfield, latitude=PlayerAirfield22.latitude, longitude=PlayerAirfield22.longitude, heading=PlayerAirfield22.heading})
	--OPFORAirfield=ScenEdit_AddUnit({side=OPFORAirfieldSide, type='Facility', name=OPFORAirfield22.name, dbid=SingleUnitAirfield, latitude=OPFORAirfield22.latitude, longitude=OPFORAirfield22.longitude, heading=OPFORAirfield22.heading})
else
	ScenEdit_SpecialMessage ('Player', 'Airbase creation failed')
end

--Change lat and lon below so scenario loc.
ScenEdit_AddReferencePoint({side="OPFOR", name="Centrepoint", lat=location.lat, lon=location.lon, highlighted=false})
centrePoint = ScenEdit_GetReferencePoint({side='OPFOR',name='Centrepoint'}) --tied to a reference point so it's easy to move wherever you like

if DebugModeCenterpoint == 1 then
ScenEdit_AddReferencePoint({side="Player", name="Centerpoint", lat=location.lat, lon=location.lon, highlighted=true, locked=true})
end


--playerRadial = math.random(0,359)
playerRadial = (Tool_Bearing({latitude=PlayerAirfield.latitude, longitude=PlayerAirfield.longitude}, {latitude=centrePoint.latitude, longitude=centrePoint.longitude} ) + playerRadialOrientation + math.random(-45,45) ) % 360 
splitDistance = StartDistance / 2
enemyRadial = (playerRadial + 180)%360

playerStartPosition = World_GetPointFromBearing({
	latitude=centrePoint.latitude,
	longitude=centrePoint.longitude,
	bearing=playerRadial,
	distance=splitDistance})
	
enemyStartPosition = World_GetPointFromBearing({
	latitude=centrePoint.latitude,
	longitude=centrePoint.longitude,
	bearing=enemyRadial,
	distance=splitDistance})

--The HTML scrip creates GLOBAL variables. Not every HTML Form assigns 'OwnAircraftClass' and 'OwnAircraftLoadout'
--Assigning "X" value with the condition below means that user JUST used a form with these variables defined and is not using the global variable values from a prior run. 
if (OwnAircraftClass ~= nil or OwnAircraftLoadout ~=nil) and (OwnAircraftClass ~= "X" and OwnAircraftLoadout ~= "X")  then 
	OwnAircraftClassAndLoadout = OwnAircraftClass.."_"..OwnAircraftLoadout
	OwnAircraftClass = "X"
	OwnAircraftLoadout = "X"
end  

if (EnemyAircraftClass ~= nil or EnemyAircraftLoadout ~=nil) and (EnemyAircraftClass ~= "X" and EnemyAircraftLoadout ~= "X") then 
	EnemyAircraftClassAndLoadout = EnemyAircraftClass.."_"..EnemyAircraftLoadout
	EnemyAircraftClass = "X"
	EnemyAircraftLoadout = "X"	
end  

playerAircraft = ReturnClassAndLoadout(OwnAircraftClassAndLoadout,'_')
enemyAircraft = ReturnClassAndLoadout(EnemyAircraftClassAndLoadout,'_')

playerFlightCallsign = {}
enemyFlightCallsign = enemyCallsign.." Flight"

--Setup the Flight as opposed to individual callsigns
for i = 1, 4 do
	playerFlightCallsign[i] = playerCallsign[i].." Flight"	
end

--*** Add Playere Flights
for i = 1, OwnFlightQuantity do
	local strikeLongOffset = (i-2)*0.01*(2*BLUFORSpacing)
	AddFormationX(
		OwnAircraftQuantity,
		playerCallsign[i],
		'Player',
		playerAircraft.dbid,
		playerAircraft.loadout,
		playerStartPosition.latitude,
		playerStartPosition.longitude + strikeLongOffset,
		enemyRadial,
		StartAltitude,
		BLUFORProficiency,
		playerFlightCallsign[i],
		BLUFORSpacing,
		BLUFORFormation
	)
end

--*** Add Enemy Flights
enemyAircraftList = {}
if EnemyFlightQuantity > 0 then 

	for j = 1, EnemyFlightQuantity do 
		local enemyLatOffset = ((-1)^(j+1))*0.02*(0.2*OPFORSpacing)
		local enemyLonOffset = (j-2)*0.01*(2*OPFORSpacing)
	
		enemyAircraftList[j] = AddFormationX(
			EnemyAircraftQuantity,
			enemyCallsign..j,
			'OPFOR',
			enemyAircraft.dbid,
			enemyAircraft.loadout,
			enemyStartPosition.latitude + enemyLatOffset,
			enemyStartPosition.longitude + enemyLonOffset,
			playerRadial,
			EnemyAltitude,
			OPFORProficiency,
			enemyFlightCallsign..j,
			OPFORSpacing,
			OPFORFormation
		)
	end
end

--AddMultipleAircraft(
	--OwnFlightQuantity,
	--playerCallsign,
	--'Player',
	--playerAircraft.dbid,
	--playerAircraft.loadout,
	--playerStartPosition.latitude,
	--playerStartPosition.longitude,
	--enemyRadial,
	--StartAltitude
--)

--enemyAircraftList = AddMultipleAircraft(
	--EnemyFlightQuantity,
	--enemyCallsign,
	--'OPFOR',
	--enemyAircraft.dbid,
	--enemyAircraft.loadout,
	--enemyStartPosition.latitude,
	--enemyStartPosition.longitude,
	--playerRadial,
	--EnemyAltitude
--)


--Fix an annoying popup at start that says that the scenario has ended. 
--This happens (I believe) because the scenario date is ahead of the real date, which is forced to be the scenario end date by the CMO engine. 
--TO Do try to fix the scenario end date if the Lua API is ever updated to do so (Or I just learn how to do it!) 
local scenarioVariable = VP_GetScenario()
if ScenYear >= scenarioVariable.ScenDate  then ScenYear = scenarioVariable.ScenDate  - 1 end

-- Set weather (musurca's method, modified)

--(X °C × 9/5) + 32 = Y °F




--Need to set the time BEFORE setting weather because now weather uses correction for nighttime
    

local ScenDate = ScenMonth..":".."15"..":"..ScenYear

--Correction for Pro version date format
if DateFormat == "PRO" then
	ScenDate = "15"..":"..ScenMonth..":"..ScenYear
end

ScenEdit_SetTime({Date=ScenDate, Time=TimeUTC})

-- temperature by latitude
--Dawn/Dusk correspond to table
--The uncorrected daytime temperature will be 10 deg greater than table values in CMO
--The uncorrected nighttime temperature will be 10 deg less than table values in CMO
local TempVsLat = {  --Uses Wikipedia climate data from the following locations: Greenlandic Weather Station, Anchorage, Huntsville, Kisangani, Adelaide, Ushuaia, McMurdo Station  
	{lat=90, tempJune=-5, tempDec=-30}, 
	{lat=75, tempJune=5, tempDec=-20},
	{lat=60, tempJune=15, tempDec=-5},
	{lat=45, tempJune=20, tempDec=5},
	{lat=30, tempJune=25, tempDec=10},
	{lat=15, tempJune=25, tempDec=15},
	{lat=0, tempJune=25, tempDec=25},
	{lat=-15, tempJune=15, tempDec=22},
	{lat=-30, tempJune=10, tempDec=20},
	{lat=-45, tempJune=5, tempDec=15},
	{lat=-60, tempJune=-5, tempDec=5},
	{lat=-75, tempJune=-20, tempDec=0},
	{lat=-90, tempJune=-30, tempDec=-5}
}

-- linear interpolate on temperature curve
local baseTemperature
for k,v in ipairs (TempVsLat) do
	local latA, latB = TempVsLat[k].lat, TempVsLat[k+1].lat
	if latA >=location.lat+0 and latB <=location.lat+0 then
		local tempA, tempB 
			if ScenMonth == 6 then
				tempA, tempB = TempVsLat[k].tempJune, TempVsLat[k+1].tempJune
			elseif ScenMonth == 12 then 
				tempA, tempB = TempVsLat[k].tempDec, TempVsLat[k+1].tempDec
			else
				empA, tempB = TempVsLat[k].tempJune, TempVsLat[k+1].tempJune
			end
		local q = (location.lat - latB) / (latA - latB)
		baseTemperature = q*tempA + (1-q)*tempB
		
		--Correct for CMO's unreasonable 20deg C day/night variation
		--Note that baseTemperature as extrapolated from the table no longer equals the observed dawn/dusk temperature after the correction is applied  
		--That means scenario temperature is not season/location 'accurate' if the time of day changes during the scenario (day to dusk, etc.) or as you move away from the starting location.
		local localTimeOfDay = ScenEdit_GetTimeOfDay({lat=location.lat, lon=location.lon})
		if localTimeOfDay.TOD == "night" then
			
			baseTemperature = baseTemperature + 5   --Add back 5 deg for nighttime. Result is 5deg less than ave. daily temperature
			
		elseif localTimeOfDay.TOD == "day" then
		
			baseTemperature = baseTemperature - 5   --Subtracts 5 deg for daytime. Result is 5deg greater than ave. daily temperature
		
		end
		
        --print(baseTemperature)
		if DebugModeTemp == '1' or DebugModeTemp == 1  then
			ScenEdit_MsgBox ("Base Temp. = "..baseTemperature..",   TOD = "..localTimeOfDay.TOD..",   Lat =  "..location.lat, 1)
		else
			--ScenEdit_MsgBox ("DebugModeTemp ==  "..DebugModeTemp, 1)
        end
		break
	end
end


--the weather values below are just examples, temperature could probably do with some adjustment
--FIXED Weather, rainfall is 0-50 NOT 0-100
weatherTable = {
	{key=0, rainfall =0, undercloud=0, seastate =0, temperature=2},
	{key=1, rainfall =0, undercloud=0.1, seastate =1, temperature=1},
	{key=2, rainfall =0, undercloud=0.2, seastate =2, temperature=0},
	{key=3, rainfall =0, undercloud=0.3, seastate =3, temperature=0},
	{key=4, rainfall =0, undercloud=0.4, seastate =4, temperature=0},
	{key=5, rainfall =10/2, undercloud=0.5, seastate =5, temperature=-1},
	{key=6, rainfall =25/2, undercloud=0.6, seastate =6, temperature=-1},
	{key=7, rainfall =40/2, undercloud=0.7, seastate =7, temperature=-2},
	{key=8, rainfall =55/2, undercloud=0.8, seastate =8, temperature=-2},
	{key=9, rainfall =70/2, undercloud=0.9, seastate =9, temperature=-3},
	{key=10, rainfall =100/2, undercloud=1, seastate =9, temperature=-3},
}

for k,v in ipairs (weatherTable) do
	if v.key == Weather then
		ScenEdit_SetWeather(v.temperature + baseTemperature, v.rainfall, v.undercloud, v.seastate)
    end
end

--29.167nm is a 5 minute stretch at 350kt; this will add one point in front and behind the Red aircraft so they start in the middle of their patrol zone
--Revision: The origional method had the OPFOR turn away too early during long range engagements. It too easy to hit them from behind. 
missionPatrolPoints = {
	--World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=playerRadial}),
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=enemyRadial}),
}

missionReferencePoints={}

for k,v in ipairs (missionPatrolPoints) do
	local referencePoint = ScenEdit_AddReferencePoint({side='OPFOR',name='Ref '..k,latitude=v.latitude,longitude=v.longitude})
	table.insert(missionReferencePoints,referencePoint.guid)
end

table.insert(missionReferencePoints, centrePoint.guid) --Just use the 'centrePoint' as the second mission reference point to keep facing the Player's flights for longer   

local mission = ScenEdit_AddMission ('OPFOR', 'OPFOR Mission', 'Patrol', {type='AAW',zone=missionReferencePoints})
ScenEdit_SetMission('OPFOR', mission.name, {StationAltitudeAircraft=EnemyAltitude, AttackAltitudeAircraft=EnemyAltitude, StationThrottleAircraft=OPFORThrottle}) 



for j = 1, EnemyFlightQuantity do

	for k,v in ipairs (enemyAircraftList[j]) do
		ScenEdit_AssignUnitToMission(v.guid,mission.guid)
	end

end



ScenEdit_SetDoctrine({side='Player'},{bvr_logic=PlayerBVR, automatic_evasion=PlayerAutoEvade, ignore_plotted_course=PlayerIPC})
ScenEdit_SetDoctrine({mission=mission.name,side=mission.side},{weapon_control_status_air=ROEValue, bvr_logic=EnemyBVR, automatic_evasion=EnemyAutoEvade, ignore_plotted_course=EnemyIPC})
ScenEdit_SetEMCON("Mission", mission.name, EnemyEMCON)
ScenEdit_SetEMCON("Side", "Player", PlayerEMCON)
SetA2A_WRA_MaxRange('Player')
SetA2A_WRA_MaxRange('OPFOR')


--New special action to show range marks from selected unit
local description1 = "Show markings of distance from the selected unit along its heading at 2 nm and 5-50 nm in 5nm increments."
local LfCR = '\r\n'
local a

a =    "local selectedUnitPartial = ScenEdit_SelectedUnits()"..LfCR
a = a.."local selectedGUID = selectedUnitPartial.units[1].guid"..LfCR
a = a.."local selectedUnitFull=ScenEdit_GetUnit({guid=selectedGUID})"..LfCR

a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 2 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 2.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 5 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 5.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 10 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 10.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 15 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 15.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 20 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 20.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 25 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 25.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 30 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 30.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 35 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 35.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 40 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 40.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 45 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 45.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
a = a.."ScenEdit_AddReferencePoint ({side = 'Player', name = ' 50 nm', relativeto = selectedUnitFull.guid, bearing = selectedUnitFull.heading, distance = 50.0, bearingtype = 1, highlighted = true, locked = true})"..LfCR
ScenEdit_AddSpecialAction({side = "Player", ActionNameOrID = "Show Range Marks from Selected Unit", description = description1, IsActive = true, IsRepeatable = true, ScriptText = a})
 
local description2 = "Delete one set of range marking."
local b
b =    "ScenEdit_SetReferencePoint ({side = 'Player', name = ' 2 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 5 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 10 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 15 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 20 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 25 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 30 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 35 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 40 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 45 nm', locked = false})"..LfCR
b = b.."ScenEdit_SetReferencePoint ({side = 'Player', name = ' 50 nm', locked = false})"..LfCR

b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 2 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 5 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 10 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 15 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 20 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 25 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 30 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 35 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 40 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 45 nm' })"..LfCR
b = b.."ScenEdit_DeleteReferencePoint({side = 'Player', name = ' 50 nm' })"..LfCR

ScenEdit_AddSpecialAction({side = "Player", ActionNameOrID = "Delete Range Grid", description = description2, IsActive = true, IsRepeatable = true, ScriptText = b})	
